unit URP_OR;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.ExtCtrls, Vcl.ComCtrls,

  UMetBase, Vcl.StdCtrls, math;

type
  TFRP_OR = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit1: TEdit;
    ScrollBox1: TScrollBox;
    Image4: TImage;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Button5: TButton;
    Button6: TButton;
    Label6: TLabel;
    Edit2: TEdit;
    Label7: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    opcion  : byte;
    ImLoc   : MatImg;
    BMLoc   : TBitMap;
    Hx,Hy   : array of integer;

  end;

var
  FRP_OR: TFRP_OR;

implementation

{$R *.dfm}

// create
procedure TFRP_OR.FormCreate(Sender: TObject);
begin
  BMLoc := TBitMap.Create;
  BMLoc.PixelFormat := pf24bit;
end;

procedure TFRP_OR.FormShow(Sender: TObject);
begin
  PageControl1.ActivePageIndex := opcion;
end;

(* ------------------------------------------------------------ *)
//                             Caso de un objeto

// Mostrar
procedure TFRP_OR.Button1Click(Sender: TObject);
begin
  Mat2BitMap(ImLoc,BMLoc);
  Image1.Picture.Assign(BMLoc);
end;

// Conteo y localizacin
procedure TFRP_OR.Button2Click(Sender: TObject);
var
  nx,ny, kk, jj,
  xmax,ymax,
  xc,yc,
  umbral,
  Ax,Ay         : integer;
  fx,fy         : single;
  LienzoX,
  LienzoY       : TCanvas;

begin
  nx := ImLoc.nc;
  ny := ImLoc.nr;
  SetLength(Hx,nx);
  SetLength(Hy,ny);

  // horizontal
  for kk := 0 to nx-1 do begin
    Hx[kk] := 0;
    for jj := 0 to ny-1 do
      Hx [kk] := Hx[kk] + ceil(ImLoc.dat[kk][jj][0]/250);
  end;

  // vertical
  for jj := 0 to ny-1 do begin
    Hy[jj] := 0;
    for kk := 0 to nx-1 do
      Hy [jj] := Hy[jj] + ceil(ImLoc.dat[kk][jj][0]/250);
  end;

  // Trazado del Histograma vertical
  // mximo
  xmax := Hx[0]; xc := 0;
  for kk := 1 to nx-1 do begin
    if (xmax<Hx[kk]) then xc := kk;
    xmax := MAX(xmax, Hx[kk]);
  end;

  fx := (Image3.Height-4)/(xmax+1);
  LienzoX := Image3.Canvas;

  LienzoX.MoveTo(0,2 + ceil(fx*Hx[0]) );
  for kk := 1 to nx-1 do
    LienzoX.LineTo(kk,2 + ceil(fx*Hx[kk]) );

  // Trazado del Histograma Horizontal
  // mximo
  ymax := Hy[0]; yc := 0;
  for kk := 1 to ny-1 do begin
    if (ymax<Hy[kk]) then yc := kk;
    ymax := MAX(ymax, Hy[kk]);
  end;

  fy := (Image2.Width-4)/(ymax+1);
  LienzoY := Image2.Canvas;

  LienzoY.MoveTo(2 + ceil(fy*Hy[0]), 0 );
  for kk := 1 to ny-1 do
    LienzoY.LineTo(2 + ceil(fy*Hy[kk]), kk );

  // anchos  -> dimetro
  umbral := StrToInt(Edit1.Text);

  Ax := 0; kk := 0;
  while (Hx[kk] <= umbral) and (kk<nx) do inc(kk);
  while (Hx[kk] >  umbral) and (kk<nx) do begin inc(Ax); inc(kk); end;

  Ay := 0; kk := 0;
  while (Hy[kk] <= umbral) and (kk<ny) do inc(kk);
  while (Hy[kk] >  umbral) and (kk<ny) do begin inc(Ay); inc(kk); end;

  // reportar
  Label1.Caption := 'Centro: '+ Format('( %3d , %3d )',[xc,yc]);
  Label2.Caption := 'AnchoX = '+ IntToStr(Ax);
  Label3.Caption := 'AnchoY = '+ IntToStr(Ay);
  Label4.Caption := 'P-Radio = '+ Format('%5.1f',[(Ax+Ay)/2]);
end;

(* ------------------------------------------------------------ *)
//                     Caso de N objetos

procedure TFRP_OR.Button3Click(Sender: TObject);
begin
  Mat2BitMap(ImLoc,BMLoc);
  Image4.Picture.Assign(BMLoc);
end;

// limpia el Memo
procedure TFRP_OR.Button5Click(Sender: TObject);
begin
  Memo1.Lines.Clear;
end;

// reconocer objetos
procedure TFRP_OR.Button4Click(Sender: TObject);
var
  umb    : single;
  let    : string;
  kx,ky  : integer;
  x0,y0  : integer;
  nc,nr  : integer;

  xx,cc,
  Ax,Ay,
  xc,yc,
  xmed,yy,
  xinf,xsup,
  xmin,ymin,
  xmax,ymax   : integer;

begin
  umb := StrToFloat(Edit2.Text);

  Memo1.Clear;

  nc  := IMLoc.nc;
  nr  := IMLoc.nr;
  if (nc*nr=0) then begin
    ShowMessage('No ha cargado alguna imagen');
    exit;
  end;

  // buscamos el primer objeto
  ky := 0;

  while (ky<nr-1) do begin
    kx := 0;
    while (kx<nc) and (ImLoc.dat[kx][ky][0]<umb) do inc(kx);
    if (ky<nr) and (kx=nc)
      then inc(ky)
      else begin
        Ax  := 0;

        x0  := kx;
        y0  := ky;
        let := Format ('x0=%4d y0=%4d', [x0,y0]);
        Memo1.Lines.Add(let);

        // caracterizar el objeto
        xmed := x0;  yy := y0;
        xinf := xmed;
        xsup := xmed;
        repeat
          xmin := xmed;
          while (IMLoc.dat[xmin][yy][0]>=umb) do dec(xmin);
          xmax := xmed;
          while (IMLoc.dat[xmax][yy][0]>=umb) do inc(xmax);

          // caja horizontal de contencin
          xinf := MIN (xinf,xmin);
          xsup := MAX (xsup,xmax);

          // ancho del renglon interior corriente
          Ax := MAX(Ax,xmax-xmin+1);

          // limpiamos la linea interior
          for xx := xmin to xmax do
            for cc := 0 to 2 do
              IMLoc.dat[xx][yy][cc] := 0;

          // nuevo centro
          xmed := ceil((xmax+xmin)/2);

          // linea siguiente
          inc(yy);

          // inspeccionamos si seguimos dentro del objeto
        until(IMLoc[xmed][yy][0]< umb);

        // caractersticas
        Ay := yy-y0;
        yc := ceil((yy+y0)/2);
        Ax := xsup-xinf+1;
        xc := ceil((xinf+xsup)/2);

        let := Format('%5d %5d %5d %5d',[xc,yc,Ax,Ay]);
        Memo1.Lines.Add(let);
      end;
  end;




end;



end.
